//<c>   Copyright 1995-2000 by Gerry J. Danen; all rights reserved.

//<t>   Check whether a particular TSR (or set of TSRs) is installed

//      Requires DIS library to recompile.

#include"gd_tools.h"


BOOL    ynANSI=FALSE, ynAPPEND=FALSE, ynASSIGN=FALSE, ynDOSKEY=FALSE, ynHIMEM=FALSE, ynNLSFUNC=FALSE, ynPRINT=FALSE, ynSHARE=FALSE ;


BOOL    show( STRING name, int loaded )
{
    printf( "%s is%s loaded\n", name, loaded ? "" : " not" );
    return( loaded );
}


void    main( int argc, char *argv[] )
{
    int         tsrLoaded = 0, tsrCount = 0, x ;
    STRING      tsrName = "" ;

    tsrLoaded = ISLOADED_DOSKEY() ? 1 : 0 ;
    tsrName = "DOSKEY" ;

    if ( argc < 2 )
    {
        printf( "Enter name(s) of TSRs to check\n" );
        exit( 0 );
    }

    LOOP( x, 1, (argc-1), 1 )
    {
        tsrName = strupr( argv[x] );
        if ( st_eq( tsrName, "ANSI" ) || st_eq( tsrName, "ANSI.SYS" ) )
        {
            tsrLoaded = ISLOADED_ANSI() ? 1 : 0 ;
            ynANSI = show( tsrName, tsrLoaded );
        }
        else
        if ( st_eq( tsrName, "HIMEM" ) || st_eq( tsrName, "HIMEM.SYS" ) )
        {
            tsrLoaded = ISLOADED_HIMEM() ? 1 : 0 ;
            ynHIMEM = show( tsrName, tsrLoaded );
        }
        else
        if ( st_eq( tsrName, "APPEND" ) )
        {
            tsrLoaded = ISLOADED_APPEND() ? 1 : 0 ;
            ynAPPEND = show( tsrName, tsrLoaded );
        }
        else
        if ( st_eq( tsrName, "ASSIGN" ) )
        {
            tsrLoaded = ISLOADED_ASSIGN() ? 1 : 0 ;
            ynASSIGN = show( tsrName, tsrLoaded );
        }
        else
        if ( st_eq( tsrName, "DOSKEY" ) )
        {
            tsrLoaded = ISLOADED_DOSKEY() ? 1 : 0 ;
            ynDOSKEY = show( tsrName, tsrLoaded );
        }
        else
        if ( st_eq( tsrName, "NLSFUNC" ) )
        {
            tsrLoaded = ISLOADED_NLSFUNC() ? 1 : 0 ;
            ynNLSFUNC = show( tsrName, tsrLoaded );
        }
        else
        if ( st_eq( tsrName, "PRINT" ) )
        {
            tsrLoaded = ISLOADED_PRINT() ? 1 : 0 ;
            ynPRINT = show( tsrName, tsrLoaded );
        }
        else
        if ( st_eq( tsrName, "SHARE" ) )
        {
            tsrLoaded = ISLOADED_SHARE() ? 1 : 0 ;
            ynSHARE = show( tsrName, tsrLoaded );
        }
        else
            printf( "Unknown TSR \"%s\" ignored.\a\n"
                    "Can only check ANSI, APPEND, ASSIGN, DOSKEY, HIMEM, NLSFUNC, PRINT, or SHARE.\n\n",
                    tsrName );
    }

    if ( ynANSI )
        tsrCount += 1 ;
    if ( ynAPPEND )
        tsrCount += 1 ;
    if ( ynASSIGN )
        tsrCount += 1 ;
    if ( ynDOSKEY )
        tsrCount += 1 ;
    if ( ynHIMEM )
        tsrCount += 1 ;
    if ( ynNLSFUNC )
        tsrCount += 1 ;
    if ( ynPRINT )
        tsrCount += 1 ;
    if ( ynSHARE )
        tsrCount += 1 ;

    printf( "%d requested TSR%s detected\n", tsrCount, tsrCount==1 ? "" : "s" );

    exit( tsrCount );
}
